clang 10.0.0git

Public Member Functions | Friends | List of all members
clang::ModuleMap::KnownHeader Class Reference

A header that is known to reside within a given module, whether it was included or excluded. More...

`#include "clang/Lex/ModuleMap.h"`

## Public Member Functions
| KnownHeader ()
| KnownHeader (Module *M, ModuleHeaderRole Role)
Module * | getModule () const
| Retrieve the module the header is stored in. More...
ModuleHeaderRole | getRole () const
| The role of this header within the module. More...
bool | isAvailable () const
| Whether this header is available in the module. More...
bool | isAccessibleFrom (Module *M) const
| Whether this header is accessible from the specified module. More...
| operator bool () const

## Friends
bool | operator== (const KnownHeader &A, const KnownHeader &B)
bool | operator!= (const KnownHeader &A, const KnownHeader &B)

## Detailed Description

A header that is known to reside within a given module, whether it was included or excluded.

Definition at line 155 of file ModuleMap.h.

## Constructor & Destructor Documentation

## ◆ KnownHeader() [1/2]

clang::ModuleMap::KnownHeader::KnownHeader | ( |  | ) |
| inline

Definition at line 159 of file ModuleMap.h.

## ◆ KnownHeader() [2/2]

clang::ModuleMap::KnownHeader::KnownHeader | ( | Module * | M,
|  | ModuleHeaderRole | Role
| ) |  |
| inline

Definition at line 160 of file ModuleMap.h.

## Member Function Documentation

## ◆ getModule()

Module* clang::ModuleMap::KnownHeader::getModule | ( |  | ) | const
| inline

Retrieve the module the header is stored in.

Definition at line 170 of file ModuleMap.h.

Referenced by clang::Preprocessor::checkModuleIsAvailable(), clang::ModuleMap::diagnoseHeaderInclusion(), clang::ModuleMap::findModuleForHeader(), clang::Preprocessor::getModuleForLocation(), isBetterKnownHeader(), suggestModule(), and violatesPrivateInclude().

## ◆ getRole()

ModuleHeaderRole clang::ModuleMap::KnownHeader::getRole | ( |  | ) | const
| inline

The role of this header within the module.

Definition at line 173 of file ModuleMap.h.

Referenced by isBetterKnownHeader(), suggestModule(), and violatesPrivateInclude().

## ◆ isAccessibleFrom()

bool clang::ModuleMap::KnownHeader::isAccessibleFrom | ( | Module * | M | ) | const
| inline

Whether this header is accessible from the specified module.

Definition at line 181 of file ModuleMap.h.

References clang::Module::getTopLevelModule().

Referenced by violatesPrivateInclude().

## ◆ isAvailable()

bool clang::ModuleMap::KnownHeader::isAvailable | ( |  | ) | const
| inline

Whether this header is available in the module.

Definition at line 176 of file ModuleMap.h.

## ◆ operator bool()

clang::ModuleMap::KnownHeader::operator bool | ( |  | ) | const
| inline explicit

Definition at line 188 of file ModuleMap.h.

## Friends And Related Function Documentation

## ◆ operator!=

bool operator!= | ( | const KnownHeader & | A,
|  | const KnownHeader & | B
| ) |  |
| friend

Definition at line 165 of file ModuleMap.h.

## ◆ operator==

bool operator== | ( | const KnownHeader & | A,
|  | const KnownHeader & | B
| ) |  |
| friend

Definition at line 162 of file ModuleMap.h.

The documentation for this class was generated from the following file:

- include/clang/Lex/ModuleMap.h